/* Generic array accessing */
/* This would hurt a little less in C++ */
/* It would hurt a LOT less in anything that does generic arithmetic
   and decent generic array accessing */
#ifndef GAH_H
#define GAH_H

/* We use HDF-EOS 5 type numbers for double/float/int/short/char/unsigned */
#include "HE5_HdfEosDef.h"

struct gah {
  void *base;
  int type;
  int dimcount;
  long dim;
};

struct gah *new_gah (void *b, int t, int dc);

long get_gah_dimension(const struct gah *g, int d);
void set_gah_dimension(struct gah *g, int d, long v);

long gah_offset(const struct gah *g,  const long *vec);
double get_gah_value(const struct gah *g, const long *vec);
void set_gah_value(struct gah *g, const long *vec, double v);

int gah_iter(const struct gah *g, long *vec, const char *mask);
#define gah_iterate(g,v) gah_iter(g, v, NULL)
#define gah_iterate_masked(g, v, m) gah_iter(g, v, m)

#endif
